/* $VER: vlink ldscript.h V0.6e (29.08.99)
 *
 * This file is part of vlink, a portable linker for multiple
 * object formats.
 * Copyright (c) 1997-2001  Frank Wille
 *
 * vlink is freeware and part of the portable and retargetable ANSI C
 * compiler vbcc, copyright (c) 1995-2001 by Volker Barthelmann.
 * vlink may be freely redistributed as long as no modifications are
 * made and nothing is charged for it. Non-commercial usage is allowed
 * without any restrictions.
 * EVERY PRODUCT OR PROGRAM DERIVED DIRECTLY FROM MY SOURCE MAY NOT BE
 * SOLD COMMERCIALLY WITHOUT PERMISSION FROM THE AUTHOR.
 *
 *
 * v0.6e (29.08.99) phx
 *       File created.
 */


#define MAXLEN 128  /* maximum length for symbols */


struct LdSymbol {
  struct LdSymbol *next;
  char *name;
  unsigned long value;
};


struct LdFuncs {
  char *name;
  void (*funcptr)();
};


struct LdScript {
  struct FFFuncs *fff;  /* target file format specific functions */
  struct MemoryDescr *memory_blocks;
  struct LdSymbol *special_symbols;
  struct list early_symbols;  /* symbol definitions before a section */
  uint8 alignment;
};



/* prototypes */
static void define_memory(struct LdScript *);
static void defmemblock(struct LdScript *,unsigned long);
static void define_sections(struct GlobalVars *,struct LdScript *);
static void dofunction(struct GlobalVars *,struct LdScript *,char *);
static void ldfunc_align(struct GlobalVars *,struct LdScript *,char *);
static struct LinkedSection *section_block(struct GlobalVars *,
                                           struct LdScript *,
                                           struct MemoryDescr *,char *);
static struct LinkedSection *symbol_assign(struct GlobalVars *,
                                           struct LdScript *,
                                           struct LinkedSection *,char *,
                                           bool);
static bool evalexp(struct LdScript *,unsigned long *,bool *);
static unsigned long readmemassign(char *);
static void endofblock(void);
static void endoffunc(void);
static void initldsyms(struct LdScript *);
static void initmemblks(struct LdScript *);
static void addldsym(struct LdScript *,char *,unsigned long);
static struct MemoryDescr *addmemblk(struct LdScript *,char *,unsigned long,
                                     unsigned long);
static struct MemoryDescr *getmemblk(struct LdScript *,char *);
static void addpattern(struct LinkedSection *,char *,char *);
static void addscriptsymbol(struct GlobalVars *,struct LdScript *,
                            struct LinkedSection *,char *,uint32,uint8,uint8);
static char *getword(void);
static char *getalnum(void);
static char *getnum(void);
static char *getpattern(void);
static char *getarg(uint8);
static char getchr(void);
static void skipblock(int,char,char);
static char *skip(char *);
static char *skipblanks(char *);
static long readval(char *);
