/* $VER: vlink pmatch.c V0.7c (12.02.00)
 *
 * This file is part of vlink, a portable linker for multiple
 * object formats.
 * Copyright (c) 1997-2001  Frank Wille
 *
 * vlink is freeware and part of the portable and retargetable ANSI C
 * compiler vbcc, copyright (c) 1995-2001 by Volker Barthelmann.
 * vlink may be freely redistributed as long as no modifications are
 * made and nothing is charged for it. Non-commercial usage is allowed
 * without any restrictions.
 * EVERY PRODUCT OR PROGRAM DERIVED DIRECTLY FROM MY SOURCE MAY NOT BE
 * SOLD COMMERCIALLY WITHOUT PERMISSION FROM THE AUTHOR.
 *
 *
 * v0.7c (02.12.00) phx
 *       Make it compile with IRIX, which doesn't have BSD's fnmatch().
 * v0.6e (23.08.99) phx
 *       File created.
 */


#define PMATCH_C
#include "vlink.h"

#ifdef AMIGAOS
#pragma amiga-align
#include <dos/dos.h>
#include <proto/dos.h>
#pragma default-align

#else /* Unix */
#ifdef _SGI_SOURCE
#include <libgen.h>
#else
#include <fnmatch.h>
#endif
#endif



#ifdef AMIGAOS

bool pattern_match(char *pat,char *str)
{
  char c,*pat1,*pat2;
  LONG len;
  bool rc = FALSE;

  /* convert Unix to AmigaDos pattern */
  pat2 = pat1 = alloc(2*strlen(pat)+1);
  while (c = *pat++) {
    if (c == '*') {
      *pat2++ = '#';
      *pat2++ = '?';
    }
    else
      *pat2++ = c;
  }
  *pat2 = '\0';

  /* tokenize pattern and match it against str */
  len = 2*strlen(pat1)+3;
  pat2 = alloc(len);
  if (ParsePattern((STRPTR)pat1,(STRPTR)pat2,len) >= 0) {
    if (MatchPattern((STRPTR)pat2,(STRPTR)str))
      rc = TRUE;
  }
  else
    ierror("pattern_match(): ParsePattern() failed for \"%s\"",pat);

  free(pat2);
  free(pat1);
  return (rc);
}


#else /* Unix */

bool pattern_match(char *pat,char *str)
{
#ifdef _SGI_SOURCE
  return (gmatch(str,pat) != 0);
#else
  return (fnmatch(pat,str,0) == 0);
#endif
}

#endif
